Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Parameters.cpp	(revision 87)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Parameters.cpp	(revision 88)
@@ -1,4 +1,3 @@
 /*
-
  * $Id$
  *
@@ -24,6 +23,6 @@
 			  uint32_t          * nb_inst_fetch                ,
 			  uint32_t            nb_inst_decod                ,
-			  uint32_t            nb_branch_speculated         ,
-			  uint32_t            size_branch_update_prediction,
+			  uint32_t          * nb_branch_speculated         ,
+// 			  uint32_t          * size_branch_update_prediction,
 			  uint32_t            nb_context_select            ,
 			  uint32_t            size_general_data            ,
@@ -31,5 +30,7 @@
 			  Tload_balancing_t   load_balancing               ,
 			  bool             ** instruction_implemeted       ,
-			  morpheo::behavioural::custom::custom_information_t (*get_custom_information) (uint32_t))
+			  morpheo::behavioural::custom::custom_information_t (*get_custom_information) (void),
+                          bool                is_toplevel
+                          )
   {
     log_printf(FUNC,Decod,FUNCTION,"Begin");
@@ -40,6 +41,6 @@
     _nb_branch_speculated          = nb_branch_speculated         ;
     _nb_context_select             = nb_context_select            ;
-    _size_branch_update_prediction = size_branch_update_prediction;
-    _size_general_data             = size_general_data            ;
+//  _size_branch_update_prediction = size_branch_update_prediction;
+//  _size_general_data             = size_general_data            ;
     _priority                      = priority                     ;
     _load_balancing                = load_balancing               ;
@@ -52,17 +53,27 @@
 
     
-    _max_nb_inst_fetch                     = max<uint32_t>(nb_inst_fetch,nb_context);
+    _max_nb_inst_fetch                        = max<uint32_t>(nb_inst_fetch,nb_context);
+                                              
+//  _size_address_inst                        = size_general_data-2;
 
-    _size_address_inst                     = size_general_data-2;
-    _size_context_id                       = log2(nb_context          );
-    _size_depth                            = log2(nb_branch_speculated);
-    _size_inst_ifetch_ptr                  = log2(_max_nb_inst_fetch  );
+    test();
 
-    _have_port_context_id                  = _size_context_id > 0;
-    _have_port_depth                       = _size_depth      > 0;
-    _have_port_branch_update_prediction_id = _size_branch_update_prediction > 0;
-    _have_port_inst_ifetch_ptr             = _size_inst_ifetch_ptr > 0;
-    
-    test();
+    if (is_toplevel)
+      {
+        _size_context_id                      = log2(nb_context          );
+        _size_depth                           = log2(max<uint32_t>(_nb_branch_speculated,_nb_context));
+//      _size_branch_update_prediction_id     = max<uint32_t>(_size_branch_update_prediction,_nb_context);
+        _size_inst_ifetch_ptr                 = log2(_max_nb_inst_fetch  );
+        _size_instruction_address             = size_general_data-2;
+        _size_general_data                    = size_general_data;
+
+        _have_port_context_id                 = _size_context_id > 0;
+        _have_port_depth                      = _size_depth                       > 0;
+//      _have_port_branch_update_prediction_id= _size_branch_update_prediction_id > 0;
+        _have_port_inst_ifetch_ptr            = _size_inst_ifetch_ptr             > 0;
+
+        copy ();
+      }
+
     log_printf(FUNC,Decod,FUNCTION,"End");
   };
@@ -82,4 +93,14 @@
   {
     log_printf(FUNC,Decod,FUNCTION,"Begin");
+
+    log_printf(FUNC,Decod,FUNCTION,"End");
+  };
+
+#undef  FUNCTION
+#define FUNCTION "Decod::copy"
+  void Parameters::copy (void) 
+  {
+    log_printf(FUNC,Decod,FUNCTION,"Begin");
+
     log_printf(FUNC,Decod,FUNCTION,"End");
   };
